;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  zppp coded in NASM by Ritz for RACL
;;  No Copyright @2000, RACL technologies
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

global main

extern	printf
extern	scanf
extern	strlen

NULL	equ	0

section .data     

graphic1	db	0Ah,0Dh,'                         +----------------------------+',0Dh,0Ah,NULL
head		db	'                         | zppp v1.0 by Ritz for RACL |',0Dh,0Ah,NULL
graphic2	db	'                         +----------------------------+',0Ah,0Dh,0Ah,0Dh,NULL
copyright	db	'This program is totally FREE and comes with NO WARRANTY. Run from root account.         ',0xA,0xD,NULL
explain		db	'By using this simple program you will now configure a new Internet connection.',0Dh,0Ah,'Please answer to the following questions [^C to terminate]...',0Dh,0Ah,0Dh,0Ah,NULL
file1		db	0xA,'Writing /etc/ppp/options... ',NULL
file2		db	'Writing /etc/ppp/pppscript... ',NULL
file3		db	'Writing /etc/ppp/pap-secrets... ',NULL
file4		db	'Writing /etc/resolv.conf... ',NULL
script		db	'Writing connection script... ',NULL
done		db	'done.',0xD,0xA,NULL
errormex	db	'error!! Leaving... ',0xD,0xA,NULL


phone		db	'. Write here your ISP phone number: ',NULL
phonebuffer	TIMES 0x15 db NULL
lenphone	dd	NULL

device		db	'. Write here your modem device path or its symbolic link: ',NULL
devicebuffer	TIMES 0x15 db NULL
lendev		dd	NULL

user		db	'. Write here the username for your account: ',NULL
userbuffer	TIMES 0x30 db NULL
lenuser		dd	NULL

pw		db	'. Write here the password for your account: ',NULL
pwbuffer	TIMES 0x15 db NULL
lenpw		dd	NULL

domain		db	'. Write here the domain name of your ISP: ',NULL
domainbuffer	TIMES 0x15 db NULL
lendomain	dd	NULL

dns1		db	'. Write here the first DNS IP for your account (needed): ',NULL
dns1buffer	TIMES 0x15 db NULL
lendns1buffer	dd	NULL

dns2		db	'. Write here the second DNS IP for your account (n = none): ',NULL
dns2buffer	TIMES 0x15 db NULL
lendns2buffer	dd	NULL

perfect		db	0xD,0xA,'The configuration has been completed successfully!',0xD,0xA,NULL
advice		db	'To connect to the Internet, simply execute the script /usr/sbin/zppp.',0xD,0xA,NULL
advice2		db	'To let all users be able to connect, change the mode of /usr/sbin/pppd to 4755.',0xD,0xA,0xD,0xA,NULL
enjoy		db	'Enjoy!',0xD,0xA,'@2000 by Ritz for RACL',0xD,0xA,0xD,0xA,NULL

format		db	'%s',NULL

handle		dd	NULL

; ---------------------------------------------------------

optionspath	db		'/etc/ppp/options',NULL
optionshandle	dd		NULL

optionsbuffer	db		'lock',0xA
		db		'defaultroute',0xA
		db		'noipdefault',0xA
		db		'modem',0xA
optionsins	TIMES	0x15 db NULL
optionsbuffer2	db		'115200',0xA
		db		'crtscts',0xA
		db		'passive',0xA
		db		'asyncmap 0',0xA
		db		'name "'
optionsins2	TIMES	0x15 db NULL

; ---------------------------------------------------------

pppscriptpath	db		'/etc/ppp/pppscript',NULL
pppscripthandle	dd		NULL

pppscriptbuffer	db		'TIMEOUT 60',0xA
		db		'ABORT ERROR',0xA
		db		'ABORT BUSY',0xA
		db		'ABORT "NO CARRIER"',0xA
		db		'ABORT "NO DIALTONE"',0xA
		db		'"" "AT&FH0"',0xA
		db		'OK "atdt'
pppscriptins	TIMES	0x15 db NULL
pppscript2	db		'TIMEOUT 75',0xA
		db		'CONNECT',NULL

; ---------------------------------------------------------

papsecretspath	db		'/etc/ppp/pap-secrets',NULL
ppsecretshandle	dd		NULL

papsecrets1	db		'"'
papsecrets	TIMES	0x40 db NULL

; ---------------------------------------------------------

scriptpath	db		'/usr/sbin/zppp',NULL
scriptbuffer	db		'/usr/sbin/pppd -detach connect "/usr/sbin/chat -v -f /etc/ppp/pppscript"',NULL

; ---------------------------------------------------------

resolvpath	db		'/etc/resolv.conf',NULL
resolvhandle	dd		NULL

resolv		db		'search '
resolvins	TIMES	0x15 db NULL

resolv2		db		'nameserver '
resolvins2	TIMES	0x15 db NULL

resolv3		db		'nameserver '
resolvins3	TIMES	0x15 db NULL

; ---------------------------------------------------------

section .text

main:

	push	dword graphic1
	call	printf
	add	esp, 4

	push	dword head
	call	printf
	add	esp, 4

	push	dword graphic2
	call	printf
	add	esp, 4
	
	push	dword copyright
	call	printf
	add	esp, 4
	
	push	dword explain
	call	printf
	add	esp, 4
	
	push	dword phone
	call	printf
	add	esp, 4
	
	push	dword phonebuffer
	push	dword format
	call	scanf
	add	esp, 8
	
	push	dword device
	call	printf
	add	esp, 4
	
	push	dword devicebuffer
	push	dword format
	call	scanf
	add	esp, 8
	
	push	dword user
	call	printf
	add	esp, 4
	
	push	dword userbuffer
	push	dword format
	call	scanf
	add	esp, 8
	
	push	dword pw
	call	printf
	add	esp, 4
	
	push	dword pwbuffer
	push	dword format
	call	scanf
	add	esp, 8
	
	push	dword domain
	call	printf
	add	esp, 4
	
	push	dword domainbuffer
	push	dword format
	call	scanf
	add	esp, 8
	
	push	dword dns1
	call	printf
	add	esp, 4
	
	push	dword dns1buffer
	push	dword format
	call	scanf
	add	esp, 8

	push	dword dns2
	call	printf
	add	esp, 4

	push	dword dns2buffer
	push	dword format
	call	scanf
	add	esp, 8
	
; ---------------------------------------------------------

	push	dword devicebuffer
	call	strlen
	add	esp, 4
	mov	dword  [lendev], eax
	mov	ecx, eax
	inc	ecx
	mov	byte [devicebuffer+eax], 0xA
	
	mov	esi, dword devicebuffer
	mov	edi, dword optionsins
	repz	movsb

	mov	ecx, 0x28
	mov	esi, dword optionsbuffer2
	mov	edi, dword optionsins
	add	edi, dword [lendev]
	inc	edi
	repz	movsb
	
	push	dword userbuffer
	call	strlen
	mov	dword [lenuser], eax
	mov	byte [userbuffer+eax], '"'
	
	mov	ecx, eax
	inc	ecx
	mov	esi, dword userbuffer
	mov	edi, dword optionsins
	add	edi, 0x29
	add	edi, dword [lendev]
	repz	movsb
	
	mov	eax, dword optionsbuffer
	add	eax, 0x4E
	add	eax, dword [lendev]
	add	eax, dword [lenuser]
	mov	dword [eax], NULL

; ---------------------------------------------------------

	push	dword phonebuffer
	call	strlen
	mov	dword [lenphone], eax
	add	esp, 4
	
	mov	byte [phonebuffer+eax], '"'
	mov	byte [phonebuffer+eax+1], 0xA
	mov	ecx, eax
	add	ecx, 2
	
	mov	esi, dword phonebuffer
	mov	edi, dword pppscriptins
	repz	movsb

	mov	ecx, 0x13 
	mov	esi, dword pppscript2
	mov	edi, dword pppscriptins
	add	edi, eax
	add	edi, 2
	repz	movsb

	mov	eax, dword pppscriptbuffer
	add	eax, 0x71
	add	eax, dword [lenphone]
	mov	dword [eax], NULL

; ---------------------------------------------------------

	push	dword userbuffer
	call	strlen
	mov	dword [lenuser], eax
	
	mov	ecx, eax
	inc	ecx
	mov	esi, dword userbuffer
	mov	edi, dword papsecrets
	repz	movsb

	mov	dword [papsecrets+eax],0x22092A09
	
	push	dword pwbuffer
	call	strlen
	add	esp, 4
	mov	dword [lenpw], eax
	
	mov	byte [pwbuffer+eax],'"'
	mov	ecx, eax
	inc	ecx

	mov	esi, dword pwbuffer
	mov	edi, dword papsecrets
	add	edi, dword [lenuser]
	add	edi, 4
	repz	movsb
	
	mov	eax, dword papsecrets
	add	eax, 0x6
	add	eax, dword [lenuser]
	add	eax, dword [lenpw]
	mov	dword [eax], NULL

; ---------------------------------------------------------

	push	dword domainbuffer
	call	strlen
	add	esp, 4
	mov	dword [lendomain], eax
	mov	byte [domainbuffer+eax], 0xA
	mov	ecx, eax
	inc	ecx
	mov	esi, dword domainbuffer
	mov	edi, dword resolvins
	repz	movsb

	push	dword dns1buffer
	call	strlen
	add	esp, 4
	mov	dword [lendns1buffer], eax
	mov	byte [dns1buffer+eax], 0xA
	mov	ecx, eax
	inc	ecx
	mov	esi, dword dns1buffer
	mov	edi, dword resolvins2
	repz	movsb
	
	cmp	dword [dns2buffer], 0x0000006E
	jz	otherdns
	
; inizio sezione inutine se non c'e' il 2 dns ---------------

	push	dword dns2buffer
	call	strlen
	add	esp, 4
	mov	dword [lendns2buffer], eax
	mov	byte [dns2buffer+eax], 0xA
	mov	ecx, eax
	inc	ecx
	mov	esi, dword dns2buffer
	mov	edi, dword resolvins3
	repz	movsb

	mov	ecx, dword [lendns2buffer]
	add	ecx, 0xB
	mov	esi, dword resolv3
	mov	edi, dword resolvins2
	add	edi, dword [lendns1buffer]
	inc	edi
	repz	movsb

; fine sezione inutine se non c'e' il 2 dns -----------------
	
otherdns:

	mov	ecx, dword [lendns1buffer]
	add	ecx, dword [lendns2buffer]
	add	ecx, 0x16
	mov	esi, dword resolv2
	mov	edi, dword resolvins
	add	edi, dword [lendomain]
	inc	edi
	repz	movsb
	
	mov	eax, dword resolv
	add	eax, 0x1F
	add	eax, dword [lendomain]
	add	eax, dword [lendns1buffer]
	add	eax, dword [lendns2buffer]
	mov	dword [eax], NULL

; ---------------------------------------------------------

	push	dword file1
	call	printf
	add	esp, 4

	mov	eax, 0x8
	mov	ebx, dword optionspath
	mov	ecx, 0x1A4
	int	0x80
	cmp	eax, -1
	jz	near error
	mov	dword [handle], eax
	
	push	dword optionsbuffer
	call	strlen
	add	esp, 4
	
	mov	ebx, dword [handle]
	mov	ecx, dword optionsbuffer
	mov	edx, eax
	mov	eax, 0x4
	int	0x80
	
	mov	eax, 0x6
	mov	ebx, dword [handle]
	int	0x80
	
	push	dword done
	call	printf
	add	esp, 4

; ---------------------------------------------------------

	push	dword file2
	call	printf
	add	esp, 4

	mov	eax, 0x8
	mov	ebx, dword pppscriptpath
	mov	ecx, 0x1A4
	int	0x80
	cmp	eax, -1
	jz	near error
	mov	dword [handle], eax
	
	push	dword pppscriptbuffer
	call	strlen
	add	esp, 4
	
	mov	ebx, dword [handle]
	mov	ecx, dword pppscriptbuffer
	mov	edx, eax
	mov	eax, 0x4
	int	0x80
	
	mov	eax, 0x6
	mov	ebx, dword [handle]
	int	0x80
	
	push	dword done
	call	printf
	add	esp, 4

; ---------------------------------------------------------

	push	dword file3
	call	printf
	add	esp, 4

	mov	eax, 0x8
	mov	ebx, dword papsecretspath
	mov	ecx, 0x1A4
	int	0x80
	cmp	eax, -1
	jz	near error
	mov	dword [handle], eax
	
	push	dword papsecrets1
	call	strlen
	add	esp, 4
	
	mov	ebx, dword [handle]
	mov	ecx, dword papsecrets1
	mov	edx, eax
	mov	eax, 0x4
	int	0x80
	
	mov	eax, 0x6
	mov	ebx, dword [handle]
	int	0x80
	
	push	dword done
	call	printf
	add	esp, 4

; ---------------------------------------------------------

	push	dword file4
	call	printf
	add	esp, 4

	mov	eax, 0x8
	mov	ebx, dword resolvpath
	mov	ecx, 0x1A4
	int	0x80
	cmp	eax, -1
	jz	near error
	mov	dword [handle], eax
	
	push	dword resolv
	call	strlen
	add	esp, 4
	
	mov	ebx, dword [handle]
	mov	ecx, dword resolv
	mov	edx, eax
	mov	eax, 0x4
	int	0x80
	
	mov	eax, 0x6
	mov	ebx, dword [handle]
	int	0x80
	
	push	dword done
	call	printf
	add	esp, 4
	
; ---------------------------------------------------------

	push	dword script
	call	printf
	add	esp, 4
	
	mov	eax, 0x8
	mov	ebx, scriptpath
	mov	ecx, 0x1FF
	int	0x80
	cmp	eax, -1
	jz	near error
	mov	dword [handle], eax
	
	push	dword scriptbuffer
	call	strlen
	add	esp, 4

	mov	ebx, dword [handle]
	mov	ecx, dword scriptbuffer
	mov	edx, eax
	mov	eax, 0x4
	int	0x80
	
	mov	eax, 0x6
	mov	ebx, dword [handle]
	int	0x80
	
	push	dword done
	call	printf
	add	esp, 4
	
; ---------------------------------------------------------

	push	dword perfect
	call	printf
	add	esp, 4

	push	dword advice
	call	printf
	add	esp, 4

	push	dword advice2
	call	printf
	add	esp, 4
	
	push	dword enjoy
	call	printf
	add	esp, 4
	jmp	exit

error:
	push	dword errormex
	call	printf
	add	esp, 4
	
exit:
	mov	eax, 1
	xor	ebx, ebx
	int	0x80
